import java.applet.Applet;
import java.awt.*;

public class Maatriks3 extends Applet{    
  double nurk=Math.PI/6;
  Maatriks muutus=new Maatriks(
    Math.cos(nurk), Math.sin(nurk),
    -Math.sin(nurk), Math.cos(nurk)
  );

  Maatriks asukoht=Maatriks.XY(30, 10);
  int keskx=150, kesky=150;
  
  public void joonistaTeljed(Graphics g){
    g.drawLine(keskx, 0, keskx, 2*kesky);
    g.drawLine(0, kesky, 2*keskx, kesky);
  }

  public void joonistaKujund(Graphics g, int kx, int ky){
    g.drawOval(keskx+kx-5, kesky-ky-5, 10, 10);
  }

  public void paint(Graphics g){
    joonistaTeljed(g);
    joonistaKujund(g, asukoht.X(), asukoht.Y());
    Maatriks uuskoht=asukoht.korruta(muutus);
    g.setColor(Color.blue);
    joonistaKujund(g, uuskoht.X(), uuskoht.Y());
  }  
  public static void main(String argumendid[]){
    Frame f=new Frame();
    f.add(new Maatriks3());
    f.setSize(300, 300);
    f.setVisible(true);
  }
}