import java.awt.image.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
public class Pildiloomine4 extends Applet implements MouseListener, Runnable{
   int hx=100, hy=100;
   int pildinr=0, ooteaeg=100;
   Image pildid[];
   double lainepikkus=20;
   boolean veel;
   int kaadritearv=15;
   public Pildiloomine4(){
     addMouseListener(this);
     new Thread(this).start();
   }
   public Image looLainetus(int laius, int korgus, int kx, int ky,
                                  double lainepikkus, double faas){
        int punktid[] = new int[laius*korgus];
        int nr=0;
        for (int y = 0; y < korgus; y++){
            for (int x = 0; x < laius; x++) {
                int punane=125+(int)(125*Math.sin(kaugus(x, y, kx, ky)*2*Math.PI/lainepikkus+faas));
                int sinine =  200;
                punktid[nr++] = (255<<24)|(punane << 16) | sinine;
            }
        }
        return createImage(new MemoryImageSource(laius, korgus, punktid, 0, laius));
   }
   
   public Image[] looPildiseeria(int laius, int korgus, int kx, int ky, 
                  double lainepikkus, int kaadritearv){
      Image[] pildikaadrid=new Image[kaadritearv];
      for(int i=0; i<kaadritearv; i++){
        pildikaadrid[i]=looLainetus(laius, korgus, kx, ky, lainepikkus, 2*Math.PI*i/kaadritearv);
      }
      return pildikaadrid;
   }
   
   public void arvutaPildid(){
     pildid=looPildiseeria(getSize().width, getSize().height, hx, hy, lainepikkus, kaadritearv);
     if(pildinr>=pildid.length)pildinr=0;
   }
   
   public void run(){
    veel=true;
    while(veel){
     if(pildid!=null && ++pildinr>=pildid.length)pildinr=0;
     repaint();
     try{Thread.sleep(ooteaeg);}catch(Exception e){}
    }
   }

   static double kaugus(double x1, double y1, double x2, double y2){
     double vahex=x2-x1;
     double vahey=y2-y1;
     return Math.sqrt(vahex*vahex+vahey*vahey);     
   }
   
   public void paint(Graphics g){
        if(pildid!=null && pildinr<pildid.length)
           g.drawImage(pildid[pildinr], 0, 0, null);
        else {
           arvutaPildid();
           g.drawString("arvutatakse", 10, 50);
        }
   }
   
   public void update(Graphics g){
     paint(g);
   }

   public void mousePressed(MouseEvent e){
     hx=e.getX();
     hy=e.getY();
     arvutaPildid();
     repaint();
   }
   public void mouseReleased(MouseEvent e){}
   public void mouseClicked(MouseEvent e){}
   public void mouseEntered(MouseEvent e){}
   public void mouseExited(MouseEvent e){}

  public static void main(String argumendid[]){
    Frame f=new Frame();
    f.add(new Pildiloomine4());
    f.setSize(200, 220);
    f.setVisible(true);
  }
} 
 
