using System;
class Erind3{
   public static void Main(string[] arg){
     try{
        if(arg.Length!=1){
          Console.WriteLine("Kasuta kujul: Erind3 sisendarv");
          return;
        }
        string tekst1=arg[0];
        int arv1=int.Parse(tekst1);
        Console.WriteLine("Sisestati edukalt "+arv1);
     } catch(FormatException probleem){
        Console.WriteLine("Viga sisendandmetega: "+probleem.Message);
     } catch(OverflowException){
        Console.WriteLine("Liiga suur arv.");
     } catch(Exception){
        Console.WriteLine("Tundmatu probleem");
     } finally{
        Console.WriteLine("Plokk otsas");
     }     
   }
}

/*
C:\Projects\oma\naited>Erind3
Kasuta kujul: Erind3 sisendarv
Plokk otsas

C:\Projects\oma\naited>Erind3 tere
Viga sisendandmetega: Input string was not in a correct format.
Plokk otsas

C:\Projects\oma\naited>Erind3 1234567890123456
Liiga suur arv.
Plokk otsas

C:\Projects\oma\naited>Erind3 78
Sisestati edukalt 78
Plokk otsas
*/