using System;
abstract class Kujund{   
   public abstract double kysiPohjaPindala();
   public abstract double kysiKorgus();
   public double kysiRuumala(){
      return kysiPohjaPindala()*kysiKorgus();
   }
}

class Tikutops:Kujund{
   public override double kysiPohjaPindala(){return 8;}
   public override double kysiKorgus(){return 1.5;}
}

class Vorstijupp: Kujund{
   int pikkus, raadius;
   public Vorstijupp(int upikkus, int uraadius){
      pikkus=upikkus;
      raadius=uraadius;
   }
   public override double kysiPohjaPindala(){
     return Math.PI*raadius*raadius;
   }
   public override double kysiKorgus(){
     return pikkus;
   }
}

class Test{
   public static void Main(string[] arg){
      Tikutops t=new Tikutops();
      Vorstijupp v=new Vorstijupp(10, 3);
      Console.WriteLine("Ruumalad {0} ja {1}", t.kysiRuumala(), v.kysiRuumala());
   }
}

/*
C:\Projects\oma\naited>Parilus6
Ruumalad 12 ja 282,743338823081
*/