using System;
using System.Xml;
class XML3{
  public static void Main(string[] arg){
    XmlDocument d=new XmlDocument();
    XmlDeclaration dec=d.CreateXmlDeclaration("1.0", null, null);
    XmlElement juur=d.CreateElement("linnad");
    d.AppendChild(juur);
    d.InsertBefore(dec, juur);
    XmlElement linn=d.CreateElement("linn");
    juur.AppendChild(linn);
    linn.AppendChild(d.CreateTextNode("Tallinn"));
    linn.SetAttribute("rahvaarv", "400000");
    Console.WriteLine(juur.InnerXml);
    Console.WriteLine(juur.OuterXml);
    Console.WriteLine("Linnade arv: " + juur.ChildNodes.Count);
    for(int i=0; i<juur.ChildNodes.Count; i++){
       linn=(XmlElement)juur.ChildNodes[i];
       Console.WriteLine(linn.InnerText+": "+linn.GetAttribute("rahvaarv"));
    }
    d.Save("linnad3.xml");
  }
}

/*
D:\kodu\0606\dotnet>XML3
<linn rahvaarv="400000">Tallinn</linn>
<linnad><linn rahvaarv="400000">Tallinn</linn></linnad>
Linnade arv: 1
Tallinn: 400000

D:\kodu\0606\dotnet>type linnad3.xml
<?xml version="1.0"?>
<linnad>
  <linn rahvaarv="400000">Tallinn</linn>
</linnad>
*/