using System;
using System.Xml;
class XML4{
  public static void Main(string[] arg){
    XmlDocument d=new XmlDocument();
    d.Load("linnad3.xml");
    XmlElement juur=d.DocumentElement;
    XmlElement linn=d.CreateElement("linn");
    juur.AppendChild(linn);
    linn.AppendChild(d.CreateTextNode("Tartu"));
    linn.SetAttribute("rahvaarv", "100000");
    XmlNodeList loetelu=juur.SelectNodes("linn[@rahvaarv>200000]");
    for(int i=0; i<loetelu.Count; i++){
       linn=(XmlElement)loetelu[i];
       Console.WriteLine(linn.InnerText+": "+linn.GetAttribute("rahvaarv"));
    }
    d.Save("linnad4.xml");
  }
}

/*
D:\kodu\0606\dotnet>XML4
Tallinn: 400000

D:\kodu\0606\dotnet>type linnad4.xml
<?xml version="1.0"?>
<linnad>
  <linn rahvaarv="400000">Tallinn</linn>
  <linn rahvaarv="100000">Tartu</linn>
</linnad>
*/