import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.*;

/**
* Trkitakse vlja vaid pealkirjad. Tkid koondatakse puhvrisse.
*/
public class RiiuliLappaja3a extends DefaultHandler{
  boolean kasPealkiri=false;
  StringBuffer puhver;
  public void startElement(String nimeruum, String kohalik, 
            String yhendus, Attributes at){
     if(yhendus.equals("PEALKIRI")){
       kasPealkiri=true;
       puhver=new StringBuffer();
     }
  }

  public void endElement(String nimeruum, String kohalik, 
            String yhendus){
     if(yhendus.equals("PEALKIRI")){
       kasPealkiri=false;
       System.out.println(puhver);
     }
  }

  public void characters(char[] tahed, int algus, int pikkus){
   if(kasPealkiri){
       puhver.append(new String(tahed, algus, pikkus));
   }
  }

  public static void main(String argumendid[]) throws Exception{
    XMLReader lappaja=  SAXParserFactory.newInstance().newSAXParser().getXMLReader();
    lappaja.setContentHandler(new RiiuliLappaja3a());
    lappaja.parse("raamatud1.xml");
  }
}