import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
public class Laulud5 extends HttpServlet {
    public void doGet(HttpServletRequest kysimus, 
                      HttpServletResponse vastus)
    throws IOException, ServletException
    {
      vastus.setContentType("text/html");
      PrintWriter valja = vastus.getWriter();
      valja.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" "+
          "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">");
      valja.println("<html><head>");
      valja.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\" />");
      valja.println("<title>Laulude nimekiri</title></head>\n");
      valja.println("<body><h1>Laulude nimekiri</h1>");
      try{
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        Connection cn=DriverManager.getConnection(
           "jdbc:odbc:esimene", "", "");
        Statement st=cn.createStatement();
        if(kysimus.getParameter("lisamine")!=null){
           PreparedStatement ps=cn.prepareStatement(
             "INSERT INTO laulud (pealkiri, esitaja) VALUES (?, ?)"
           );
           ps.setString(1, kysimus.getParameter("pealkiri"));
           ps.setString(2, kysimus.getParameter("esitaja"));
           ps.executeUpdate();
        }
        String sort="id";
        String sortTulp=kysimus.getParameter("sorttulp");
        if(sortTulp==null){sortTulp="id";}
        if(sortTulp.equals("pealkiri")){sort="pealkiri";}
        if(sortTulp.equals("esitaja")){sort="esitaja";}
        String lause="SELECT pealkiri, esitaja FROM laulud ORDER BY "+sort;
        ResultSet rs=st.executeQuery(lause);
        valja.println("<table>");
        valja.println("<tr>"+
           "<th><a href='"+kysimus.getRequestURI()+
           "?sorttulp=pealkiri'>Pealkiri</a></th>"+
           "<th><a href='"+kysimus.getRequestURI()+
           "?sorttulp=esitaja'>Esitaja</a></th>"+
           "</tr>");
        while(rs.next()){
         valja.println("<tr><td>"+
          Abi.filtreeriHTML(rs.getString("pealkiri"))+
          "</td><td>"+
          Abi.filtreeriHTML(rs.getString("esitaja"))+
          "</td></tr>");
        }
        valja.println("</table>");
        valja.println("<h1>Lisamine</h1>");
        valja.println(
          "<form action='#'><table>"+
          "<tr><td>Pealkiri:</td><td>"+
           "<input type='text' name='pealkiri' /></td></tr>\n"+
          "<tr><td>Esitaja:</td><td>"+
           "<input type='text' name='esitaja' /></td></tr>\n"+
          "</table>"+
          "<input type='submit' name='lisamine' value='Lisa' />"+
          "</form>"
        );
        cn.close(); 
        valja.println("</body>");
        valja.println("</html>");

      }catch(Exception viga){
         viga.printStackTrace(valja);
      }
    }
}