public class Tasandinihe{
  /**
  * Nihke koordinaatide vrtused. Piiritleja final rea ees nitab, et 
  * vrtusi prast algset omistamist enam muuta ei saa.
  */
  final double x, y;
  public Tasandinihe(double ux, double uy){
    x=ux;
    y=uy;
  }
  
  /**
  * Nihe arvutatakse etteantud kahe punkti koordinaatide jrgi
  */
  public Tasandinihe(double x1, double y1, double x2, double y2){
    x=x2-x1;
    y=y2-y1;
  }
  int X(){
    return (int)x;
  }
  int Y(){
    return (int)y;
  }
  double pikkus(){
    return Math.sqrt(x*x+y*y);
  }
 
  /**
  * Vahe samast punktist lhtuvate nihete otspunktide vahel.
  */
  double kaugus(Tasandinihe t1){
    return t1.miinus(this).pikkus();
  }
  
  /**
  * Vljastatakse nihke vrtuse ja teguri korrutis.
  * Nihe ise jb muutmata.
  */
  Tasandinihe korda(double tegur){
    return new Tasandinihe(x*tegur, y*tegur);
  }
  
  /**
  * Vljastatakse kesoleva ning parameetrina antud nihke summa.
  * Mlema nihke enese vrtus jb muutmata.
  */  
  Tasandinihe pluss(Tasandinihe t1){
    return new Tasandinihe(t1.x+x, t1.y+y);
  }
  
  Tasandinihe miinus(Tasandinihe t1){
    return this.pluss(t1.korda(-1));
  }
  
  /**
  * Suund keeratakse tisnurga jagu vastupeva.
  */
  Tasandinihe keera(){
    return new Tasandinihe(-y, x);
  }
}