from Globals import InitializeClass, DTMLFile, Persistent
from OFS.SimpleItem import Item

def lisamisVorm():
  "Lehe nime sisestusvorm"
  return """<html><head><title>Lehe nime sisestus</title></head>
    <body>
      <form action='lisamisLeht'>
        Lehe nimi: <input type='text' name='leheNimi'>
      </form>
    </body></html>"""

def lisamisLeht(lisaja, leheNimi):
  "Uus tervitaja"
  lisaja.Destination()._setObject(leheNimi, Tere5())
  return "Lisatud leht nimega " + leheNimi

class Tere5(Item, Persistent):
  "Psivate andmetega klass"
  meta_type="Tere5"
  loendur=0

  def index_html(self):
    "Vaikimisi meetod"
    self.loendur=self.loendur+1
    return "Lehte on vaadatud %d korda." % self.loendur
     
InitializeClass(Tere5)