from Globals import InitializeClass, Persistent
from OFS.SimpleItem import Item

def lisamisVorm():
  "Lehe nime sisestusvorm"
  return """<html><head><title>Lehe nime sisestus</title></head>
    <body>
      <form action='lisamisLeht'>
        Lehe nimi: <input type='text' name='leheNimi'>
      </form>
    </body></html>"""

def lisamisLeht(lisaja, leheNimi):
  "Uus tervitaja"
  lisaja.Destination()._setObject(leheNimi, Tere7())
  return "Lisatud leht nimega " + leheNimi

class Tere7(Item, Persistent):
  "Psivate andmetega klass"
  meta_type="Tere7"
  loendur=0

  def index_html(self):
    "Vaikimisi meetod"
    self.loendur=self.loendur+1
    return "Lehte on vaadatud %d korda." % self.loendur
    
  def nulli(self):
    "Lugemist alustatakse uuesti algusest"
    self.loendur=0
    
  def vaatamisteArv(self):
    "Vaatamiskordade arv"
    return self.loendur
     
InitializeClass(Tere7)