import java.security.*;
import java.security.spec.*;
import java.io.*;
public class Allkirjastaja{
  public static void main(String argumendid[]) throws Exception{
    String salavotmefail="salavoti.key";
    String andmefail="andmed.txt";
    String allkirjafail="andmed.sig";
    byte[] salavotmebaidid=new byte[(int)new File(salavotmefail).length()];
    FileInputStream sisse=new FileInputStream(salavotmefail);
    sisse.read(salavotmebaidid);
    sisse.close();
    PrivateKey salavoti=KeyFactory.getInstance("DSA").generatePrivate(
      new PKCS8EncodedKeySpec(salavotmebaidid)
    );	
    byte[] andmebaidid=new byte[(int)new File(andmefail).length()];
    sisse=new FileInputStream(andmefail);
    sisse.read(andmebaidid);
    sisse.close();   
    Signature allkirjastaja=Signature.getInstance("DSA");
    allkirjastaja.initSign(salavoti);
    allkirjastaja.update(andmebaidid);
    byte[] allkiri=allkirjastaja.sign();
    FileOutputStream valja=new FileOutputStream(allkirjafail);
    valja.write(allkiri);
    valja.close();
  }
}