import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
public class LauludPlaadil3 extends HttpServlet {
    public void doGet(HttpServletRequest kysimus, 
                      HttpServletResponse vastus)
    throws IOException, ServletException
    {
      vastus.setContentType("text/html");
      PrintWriter valja = vastus.getWriter();
      valja.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" "+
          "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">");
      valja.println("<html><head>");
      valja.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\" />");
      valja.println("<title>Laulude nimekiri</title></head>\n");
      valja.println("<body><h1>Laulud plaadil</h1>");
      try{
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        Connection cn=DriverManager.getConnection(
           "jdbc:odbc:esimene", "", "");
       if(kysimus.getParameter("lisamine")!=null){
           PreparedStatement ps=cn.prepareStatement(
             "INSERT INTO laulud_plaadid (laulu_id, plaadi_id) VALUES (?, ?)"
           );
           ps.setInt(1, Integer.parseInt(kysimus.getParameter("laul")));
           ps.setInt(2, Integer.parseInt(kysimus.getParameter("plaat")));
           ps.executeUpdate();
        }

        Statement st=cn.createStatement();
        String lause="SELECT laulud_plaadid.id as seosenr, pealkiri, plaadinimi "+
            "FROM laulud, laulud_plaadid, plaadid "+
            "WHERE laulud.id=laulud_plaadid.laulu_id AND "+
            "laulud_plaadid.plaadi_id=plaadid.id";
        valja.println("<form action='Kustutus' method='post'><table>");
        ResultSet rs=st.executeQuery(lause);
        while(rs.next()){
           valja.println("<tr>"+
            "<td><input type='checkbox' name='kustutus' value='"+
            +rs.getInt("seosenr")+"' /></td>"+
            "<td>"+rs.getString("pealkiri")+
            "</td><td>"+rs.getString("plaadinimi")+"</td></tr>");
        }
        valja.println("</table><input type='submit' value='Kustuta' /></form>");
        valja.println("<h1>Seoste lisamine</h1>");
        valja.println("<form action='#'>");
        lause="SELECT id, pealkiri FROM laulud";
        rs=st.executeQuery(lause);
        valja.println("<select name='laul'>");
        while(rs.next()){
          valja.println("  <option value='"+rs.getString("id")+
              "'>"+rs.getString("pealkiri")+"</option>");
        }
        valja.println("</select>");

        lause="SELECT id, plaadinimi FROM plaadid";
        rs=st.executeQuery(lause);
        valja.println("<select name='plaat'>");
        while(rs.next()){
          valja.println("  <option value='"+rs.getString("id")+
              "'>"+rs.getString("plaadinimi")+"</option>");
        }
        valja.println("</select>");
        valja.println("<input type='submit' name='lisamine' value='Lisa' />");
        valja.println("</form>");
        valja.println("<br /><a href='Laulud6'>Laulude haldus</a>");
        cn.close(); 
        valja.println("</body>");
        valja.println("</html>");

      }catch(Exception viga){
         viga.printStackTrace(valja);
      }
   }
}