import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Tahvel2 extends Applet 
  implements MouseListener, MouseMotionListener, JooniseKuular, ActionListener{
  int hax, hay, hyx, hyy;
  String[] kujundid={"Joon", "Ristklik", "Ovaal", "Vabakejoon"};
  Choice kujundivalik=new Choice();
  JooniseKuular kuulaja=null;
  LinkedList hoidla=new LinkedList();
  Button tyhjenda=new Button("Thjenda");
  //Lisa vabakejoon
  
  //objekt, kellele saadetakse tahvlil toimunud sndmused.
  public Tahvel2(){
    addMouseListener(this);
    addMouseMotionListener(this);
    for(int i=0; i<kujundid.length; i++){
      kujundivalik.addItem(kujundid[i]);
    }
    add(kujundivalik);
    add(tyhjenda);
    tyhjenda.addActionListener(this);
    //kuulaja=this;
  }
  public void lisaJooniseKuular(JooniseKuular j){
    kuulaja=j;
  }
  public void paint(Graphics g){     
     for(Iterator it=hoidla.iterator(); it.hasNext();){
       String s=(String)it.next();
       joonista(s);
     }
  }
  
  void joonista(String andmed){
   try{
    Graphics g=getGraphics();
    StringTokenizer stk=new StringTokenizer(andmed);
    String tyyp=stk.nextToken();
    int a[]=new int[4];
    for(int i=0; i<4; i++){
       a[i]=Integer.parseInt(stk.nextToken());
    }
    if(tyyp.equals(".pj")){
      g.drawLine(a[0], a[1], a[2], a[3]);
    }
    if(tyyp.equals(".pr")){
      g.drawRect(a[0], a[1], a[2], a[3]);
    }
    if(tyyp.equals(".po")){
      g.drawOval(a[0], a[1], a[2], a[3]);
    }
   }catch(Exception viga){viga.printStackTrace();}
  }
  
  public void kujund(String andmed){
    joonista(andmed);
    hoidla.add(andmed);
  }  
  
  public void mousePressed(MouseEvent e){
    hax=e.getX();
    hay=e.getY();
  }
  public void mouseReleased(MouseEvent e){
    hyx=e.getX();
    hyy=e.getY();  
    saada();
  }
  public void actionPerformed(ActionEvent e){
    if(e.getSource()==tyhjenda){
      hoidla.clear();
      repaint();
    }
  }
  public void mouseDragged(MouseEvent e)
  {
    if(kujundivalik.getSelectedItem().equals("Vabakejoon")){
        hyx = e.getX();
        hyy = e.getY();
        saada();
        hax = hyx;
        hay = hyy;
    }
  }
  public void mouseMoved(MouseEvent e){}

  void saada(){
    if(kuulaja==null){return;}
    int laius=hyx-hax;
    int korgus=hyy-hay;
    if(kujundivalik.getSelectedItem().equals("Joon")||
       kujundivalik.getSelectedItem().equals("Vabakejoon")){
      kuulaja.kujund(".pj "+hax+" "+hay+" "+hyx+" "+hyy);
    }
    if(kujundivalik.getSelectedItem().equals("Ristklik")){
      kuulaja.kujund(".pr "+hax+" "+hay+" "+laius+" "+korgus);
    }
    if(kujundivalik.getSelectedItem().equals("Ovaal")){
      kuulaja.kujund(".po "+hax+" "+hay+" "+laius+" "+korgus);
    }
  }
  
  public void mouseClicked(MouseEvent e){}
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  public static void main(String[] argumendid){
    Frame f=new Frame();
    f.add(new Tahvel2());
    f.setSize(300, 300);
    f.setVisible(true);
  }
}

